Functions

# townname_func.h File Reference

Town name generator stuff. More...

`#include "townname_type.h"`

Go to the source code of this file.

## Functions
char * | GenerateTownNameString (char *buf, const char *last, size_t lang, uint32 seed)
| Generates town name from given seed.
char * | GetTownName (char *buff, const TownNameParams *par, uint32 townnameparts, const char *last)
| Fills buffer with specified town name.
char * | GetTownName (char *buff, const Town *t, const char *last)
| Fills buffer with town's name.
bool | VerifyTownName (uint32 r, const TownNameParams *par, TownNames *town_names=NULL)
| Verifies the town name is valid and unique.
bool | GenerateTownName (uint32 *townnameparts, TownNames *town_names=NULL)
| Generates valid town name.

## Detailed Description

Town name generator stuff.

Definition in file townname_func.h.

## Function Documentation

bool GenerateTownName | ( | uint32 * | townnameparts,
|  | TownNames * | town_names |
| ) |  |  |

Generates valid town name.

Parameters:

  | townnameparts | if a name is generated, it's stored there
  | town_names | if a name is generated, check its uniqueness with the set

Returns:
  true iff a name was generated

Definition at line 120 of file townname.cpp.

References _generating_world, _settings_game, GameSettings::game_creation, Layouter::ReduceLineCache(), GameCreationSettings::town_name, and VerifyTownName().

Referenced by GenerateTowns().

char* GenerateTownNameString | ( | char * | buf,
|  | const char * | last,
|  | size_t | lang,
|  | uint32 | seed |
| ) |  |  |

Generates town name from given seed.

a language.

Parameters:

  | buf | output buffer
  | last | end of buffer
  | lang | town name language
  | seed | generation seed

Returns:
  last character ('/0')

Definition at line 1052 of file townname.cpp.

References AllocaM, lengthof, TownNameGeneratorParams::min, TownNameGeneratorParams::proc, and strecpy().

Referenced by FormatString().

char* GetTownName | ( | char * | buff,
|  | const TownNameParams * | par,
|  | uint32 | townnameparts,
|  | const char * | last |
| ) |  |  |

Fills buffer with specified town name.

Parameters:

  | buff | buffer start
  | par | town name parameters
  | townnameparts | 'encoded' town name
  | last | end of buffer

Returns:
  pointer to terminating ''

Definition at line 49 of file townname.cpp.

References GetStringWithArgs(), TownNameParams::grfid, and TownNameParams::type.

Referenced by FormatString(), GetTownName(), and VerifyTownName().

char* GetTownName | ( | char * | buff,
|  | const Town * | t,
|  | const char * | last |
| ) |  |  |

Fills buffer with town's name.

Parameters:

  | buff | buffer start
  | t | we want to get name of this town
  | last | end of buffer

Returns:
  pointer to terminating ''

Definition at line 68 of file townname.cpp.

References GetTownName().

bool VerifyTownName | ( | uint32 | r,
|  | const TownNameParams * | par,
|  | TownNames * | town_names |
| ) |  |  |

Verifies the town name is valid and unique.

Parameters:

  | r | random bits
  | par | town name parameters
  | town_names | if a name is generated, check its uniqueness with the set

Returns:
  true iff name is valid and unique

Definition at line 82 of file townname.cpp.

References GetTownName(), lastof, MAX_CHAR_LENGTH, MAX_LENGTH_TOWN_NAME_CHARS, Town::name, and Utf8StringLength().

Referenced by CmdFoundTown(), and GenerateTownName().